﻿init python:
    from copy import copy
    class caky_cake:
        def __init__(self, name, image, info = ""):
            self.name = name
            self.image = image
            self.info = info
            self.remove = False
            self.x = 0
            self.y = 0
    
    class caky_class:
        def __init__(self, cakes, additional_cakes):
            self.cakes = cakes
            self.additional_cakes = additional_cakes
            self.board = []
            self.fill()
            self.x_index = 0
            self.y_index = 0
            self.pushing = False
            self.stat = "playing"
            self.score = 0

        def fill(self):
            board = []
            for y in range(5):
                row = []
                for x in range(5):
                    cake = copy(random.choice(self.cakes))
                    row.append(cake)
                board.append(row)
            self.board = board
        def move_index(self, x, y):
            if not self.stat == "playing":
                return
            if x:
                xi = x + self.x_index
                if  0 > xi or xi > 4:
                    return
                self.x_index = clamp(0, self.x_index + x, 4)
                if self.pushing:
                    renpy.play("caky baky/move.ogg", "sound")
                    self.push_x(x)
                else:
                    renpy.play("caky baky/port.ogg", "sound")
            if y:
                yi = y + self.y_index
                if  0 > yi or yi > 4:
                    return
                self.y_index = clamp(0, self.y_index + y, 4)
                if self.pushing:
                    renpy.play("caky baky/move.ogg", "sound")
                    self.push_y(y)
                else:
                    renpy.play("caky baky/port.ogg", "sound")

        def push_x(self, x):
            if x > 0:
                cake = self.board[self.y_index].pop(-1)
                self.board[self.y_index].insert(0, cake)
            elif x < 0:
                cake = self.board[self.y_index].pop(0)
                self.board[self.y_index].append(cake)
        def push_y(self, y):
            if y > 0:
                last_cake = self.board[-1][self.x_index]
                for i in self.board:
                    cake = i[self.x_index]
                    i[self.x_index] = last_cake
                    last_cake = cake
            elif y < 0:
                last_cake = self.board[0][self.x_index]
                for i in reversed(self.board):
                    cake = i[self.x_index]
                    i[self.x_index] = last_cake
                    last_cake = cake

        def toggle_push(self):
            self.pushing = not self.pushing
            renpy.play("caky baky/take.ogg", "sound")
            if not self.pushing:
                self.check()
        def check(self):
            has_pop = False
            for y in self.board:
                x1 = y[0].image
                for x in y:
                    if not x.image == x1:
                        break
                else:
                    for x in y:
                        x.remove = True
                    has_pop = True
            
            for y in rotate_list(self.board):
                x1 = y[0].image
                for x in y:
                    if not x.image == x1:
                        break
                else:
                    for x in y:
                        if not x.remove:
                            x.remove = True
                    has_pop = True
            if has_pop:
                self.pop()
            else:
                self.stat = "playing"

        def pop(self):
            for y,j in enumerate(self.board):
                for x,i in enumerate(j):
                    if i.remove:
                        image_pop(i.image, (x*32,y*32), (60,-80))
            self.stat = "filling"

            # self.refill()
        def refill(self):
            for y in self.board:
                for x in y:
                    if x.remove:
                        y.remove(x)
                        cake = copy(random.choice(self.cakes))
                        y.append(cake)
                        self.score += 1
                        renpy.play("caky baky/bubble_7.ogg", "sound")
                        return
            self.check()
            

        def add(self, cake):
            self.cakes.append(cake)
            self.additional_cakes.remove(cake)
            self.score -= 50
            Hide("choose_cake")()

screen caky_screen(g):
    style_prefix "cake"
    frame:
        background Frame("cake_bg", 8,8) padding (20,20) align (.5,.08) xminimum 200
        text str(g.score) align .5,.5
    frame:
        padding 16,16 align .5,.5
        background Frame("cake_frame", 30,30)
        at zoom(3, True)
        fixed fit_first True:
            vbox:
                for y in g.board:
                    hbox:
                        for x in y:
                            fixed fit_first True:
                                add "cake_bg"
                                if not x.remove:
                                    add x.image
            frame:
                yoffset g.y_index*32
                xysize 160, 32 padding 0,0 align .5,.0
                background Frame("cake_grid_horizontal", 0, 0, tile =True)

                button:
                    at rotate(-90)
                    xoffset -32 xalign .0
                    if g.pushing:
                        background "cake_button_grab"
                    else:
                        background "cake_button_move"
                    action Function(g.move_index, -1, 0) keysym "a"
                button:
                    at rotate(90)
                    xoffset 32 xalign 1.0
                    if g.pushing:
                        background "cake_button_grab"
                    else:
                        background "cake_button_move"
                    action Function(g.move_index, 1, 0) keysym "d"
            
            frame:
                xoffset g.x_index*32
                xysize 32, 160 padding 0,0 align .0,.5
                background Frame("cake_grid_vertical", 0, 0, tile = True)

                button:
                    at rotate(0)
                    yoffset -32 yalign .0
                    if g.pushing:
                        background "cake_button_grab"
                    else:
                        background "cake_button_move"
                    action Function(g.move_index, 0, -1) keysym "w"
                button:
                    at rotate(180)
                    yoffset 32 yalign 1.0
                    if g.pushing:
                        background "cake_button_grab"
                    else:
                        background "cake_button_move"
                    action Function(g.move_index, 0, 1) keysym "s"
    if g.score > 49 and len(g.additional_cakes):
        timer .01 action Show("choose_cake", g = g)
    button:
        at zoom(3, True)
        if g.pushing:
            background "cake_button_move"
        else:
            background "cake_button_grab"
        offset -64, -64 align 1.0,1.0
        background "cake_bg"
        action Function(g.toggle_push) keysym "K_SPACE"

    if g.stat == "filling":
        timer .1 repeat True action Function(g.refill)
screen choose_cake(g):
    modal True
    add "#2d1811e1"
    vbox:
        align .5,.5
        text "Choose your next sweet." align .5,.5
        hbox:
            at zoom(3, True)
            offset -64, 64
            for i in g.additional_cakes:
                button:
                    add i.image
                    action Function(g.add, i)


    # vbox:
    #     text str(g.x_index)
    #     text str(g.y_index)
    #     text str(g.pushing)
style cake_button:
    xysize (32, 32) align (.5,.5) padding (0,0)
init:
    image cake_1 = Crop((0,0,32,32), "caky baky/sprites.png")
    image cake_2 = Crop((32,0,32,32), "caky baky/sprites.png")
    image cake_3 = Crop((64,0,32,32), "caky baky/sprites.png")
    image cake_4 = Crop((0,32,32,32), "caky baky/sprites.png")
    image cake_5 = Crop((32,32,32,32), "caky baky/sprites.png")
    image cake_6 = Crop((64,32,32,32), "caky baky/sprites.png")
    image cake_7 = Crop((0,64,32,32), "caky baky/sprites.png")
    image cake_8 = Crop((32,64,32,32), "caky baky/sprites.png")
    image cake_9 = Crop((64,64,32,32), "caky baky/sprites.png")
    image cake_10 = Crop((96,64,32,32), "caky baky/sprites.png")

    image cake_frame = Crop((0,192,64,64), "caky baky/sprites.png")
    image cake_bg = Crop((96,192,32,32), "caky baky/sprites.png")
    image cake_grid_horizontal = Crop((64,192,32,32), "caky baky/sprites.png")
    image cake_grid_vertical = Crop((96,224,32,32), "caky baky/sprites.png")
    image cake_button_grab = Crop((64,224,32,32), "caky baky/sprites.png")
    image cake_button_move = Crop((128,224,32,32), "caky baky/sprites.png")



#---------- examples
default caky_cake_1 = caky_cake("Cake", "cake_1")
default caky_cake_2 = caky_cake("Cake", "cake_2")
default caky_cake_3 = caky_cake("Cake", "cake_3")
default caky_cake_4 = caky_cake("Cake", "cake_4")
default caky_cake_5 = caky_cake("Cake", "cake_5")
default caky_cake_6 = caky_cake("Cake", "cake_6")
default caky_cake_7 = caky_cake("Cake", "cake_7")
default caky_cake_8 = caky_cake("Cake", "cake_8")
default caky_cake_9 = caky_cake("Cake", "cake_9")
default caky_cake_10 = caky_cake("Cake", "cake_10")

default caky_game_1 = caky_class(
    cakes = [
        caky_cake_1,
        caky_cake_2,
        caky_cake_3,
        ],
    additional_cakes = [
        caky_cake_4,
        caky_cake_5,
        caky_cake_6,
        caky_cake_7,
        caky_cake_8,
        caky_cake_9,
        caky_cake_10,
        ]
)





label caky_example:
    scene black
    show bg room with dissolve
    show image "#2d1811e1" with dissolve
    call screen caky_screen(caky_game_1)


